// Ansteuerung eines Lautsprechers an Pin 1.2

#include "speaker.h"
#include "io430.h"
#include "intrinsics.h"

static volatile int timerCount = 0;

#pragma vector = WDT_VECTOR
__interrupt void WDT_ISR(void)
{
  if(timerCount < 1000)
  {
      timerCount++;
  }
}

void initialize(void)
{  
  WDTCTL = WDTPW | WDTTMSEL;
  
  BCSCTL1 = CALBC1_1MHZ;
  DCOCTL = CALDCO_1MHZ;
  
  P1DIR_bit.P2 = 0;
  P1SEL_bit.P2 = 1;
  
  TACCR0 = 42;
  TACCTL1 = OUTMOD_4;
  TACTL = MC_1 | TASSEL_2 | TACLR;
  
  IE1_bit.WDTIE = 1;
  __enable_interrupt();
}

void sound(unsigned int frequency) // 0 heit Pause
{
  if(frequency > 0)
  {
    TACCR0 = 1000000/frequency/2;
    TACTL |= TACLR;
    P1DIR_bit.P2 = 1;
  }
  timerCount = 0;
  while(timerCount < 5)
  {} // unschn: busy wait
  P1DIR_bit.P2 = 0;
}